# aes-project
AES-128, and square attack against reduced AES-128 (only 4-turns) implementation in rust.

### example
encrypt the text "Hello, world!" using the key 2b7e151628aed2a6abf7158809cf4f3c, hex-encoded. 10-turns AES-128

```
cargo run -- encrypt -K -k '2b7e151628aed2a6abf7158809cf4f3c' -t "Hello, world!" -n 10
```
square attack against 4-turns AES-128, choosen key bba51a66aca801747294ff4317fb59e2, hex-encoded.
```
cargo run -- findkey bba51a66aca801747294ff4317fb59e2 -K
```
square attack against 4-turns AES-128, 10 keys generated randomly.
```
cargo run -- square 10
```
